import { Windows as S4Windows } from "syrus4-nodejs"
import { syrusjs_variables, structure, windows } from "./globals.js"


/**
 * create a new S4 Window and stored in global window object
 * @param {*} config window parameters
 */
export async function createWindow( config ) {
    const name = config.name;
    console.log('createWindow:', config);
    await S4Windows.setWindow( config );
}

export async function deleteWindow( config ) {
    if (windows[config.name]) {
        windows[config.name].watcher.unsubscribe();
        S4Windows.deleteWindow(config.name);
        delete windows[config.name];
        console.log('deleteWindow deleted:', config.name);
    }
}

export async function enableWindow( config ) {
    if (windows[config.name].watcher != undefined) {
        S4Counters.startWindow(config)
        console.log('enableWindow:', config.name);
    }	
}

export async function disableWindow(config) {
    if (windows[config.name].watcher != undefined) {
        S4Counters.stopWindow(config)
        console.log('disableWindow:', config.name);
    }	
}